/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of LevelDB.xs. Do not edit this file, edit LevelDB.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LevelDB.xs"

// Make sure C++ headers are included before PERL headers to avoid errors.
#include<iostream>
#include<leveldb/db.h>
#include<leveldb/slice.h>
#include<leveldb/iterator.h>
#include<leveldb/write_batch.h>

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

//#include <Tie::LevelDB>

#ifdef __cplusplus
}
#endif

// winnt.h already defines DELETE which overlaps our DELETE method.
#undef DELETE

void status_assert(leveldb::Status s) {
	if(!s.ok()) croak("%s",s.ToString().c_str());
}
SV* newSVstring(std::string str) {
    return newSVpvn(str.data(),str.length());
}
SV* newSVslice(leveldb::Slice slice) {
    return newSVpvn(slice.data(),slice.size());
}
std::string SV2string(SV* sv) {
    STRLEN len;
    char * ptr = SvPV(sv, len);
    return std::string(ptr,len);
}

class Iterator {
protected:
	leveldb::Iterator *it;
public:
	Iterator() {
		it = NULL; // die!
	}
	Iterator(leveldb::Iterator *it) : it(it) { }
	~Iterator() { delete it; it = NULL; }
	void SeekToFirst() { it->SeekToFirst(); }
	void SeekToLast()  { it->SeekToLast(); }
	void Seek(const SV* sv_target) {
		leveldb::Slice target(SvPVX(sv_target), SvCUR(sv_target));
		it->Seek(target);
	}
	void Next()  { it->Next(); }
	void Prev()  { it->Prev(); }
	bool Valid() { return it->Valid(); }
	SV* key() { 
		SV* k = newSVstring(it->key().ToString());
		status_assert(it->status());
		return k;
	}
	SV* value() { 
		SV* v = newSVstring(it->value().ToString());
		status_assert(it->status());
		return v;
	}
};

class WriteBatch {
protected:
	leveldb::WriteBatch *batch;
public:
	leveldb::WriteBatch* get_batch() { return batch; }

	WriteBatch() {
		batch = new leveldb::WriteBatch();
	}
	~WriteBatch() {
		delete batch;
	}
	void Put(const char* key,const char * cvalue) {
		if(cvalue) {
			std::string* value = new std::string(cvalue);
			batch->Put(key, *value);
		} else Delete(key); // LevelDB limitation..
	}
	void Delete(const char * key) {
		batch->Delete(key);
	}
};

class DB {
protected:
	leveldb::DB *db;
public:
	DB() : db(NULL) { }
	DB(const char* name,HV* hv_options=NULL ) : db(NULL) { 
		Open(name,hv_options);
	}
	~DB() {
		if(db) { delete db; db = NULL; }
	}
	void Open(const char* name,HV* hv_options=NULL) { 
		leveldb::Options options; // todo: construct
		options.create_if_missing = true;
		// options.error_if_exists = true;
		if(db) delete db;
		status_assert(leveldb::DB::Open(options, name, &db));
	}
	void Put(const char* key,const char* cvalue=NULL,
			 HV* hv_write_options=NULL) {
		leveldb::WriteOptions write_options;
		if(cvalue) {
			std::string* value = new std::string(cvalue);
			status_assert(db->Put(write_options, key, *value));
		} else {
			status_assert(db->Delete(leveldb::WriteOptions(), key));
		}
	}
	SV* Get(const char* key) {
		std::string value;
		leveldb::Status s = db->Get(leveldb::ReadOptions(), key, &value);
		if(s.IsNotFound()) return NULL;
		status_assert(s);
		return newSVstring(value);
	}
	void Delete(const char* key) {
		status_assert(db->Delete(leveldb::WriteOptions(), key));
	}
	void Write(WriteBatch* batch,HV* hv_write_options=NULL) {
		leveldb::WriteOptions write_options; // todo: construct
		status_assert(db->Write(write_options,batch->get_batch()));
	}
	Iterator* NewIterator(HV* hv_read_options=NULL) {
		leveldb::ReadOptions read_options; // todo: construct
		return new Iterator(db->NewIterator(read_options));
	}
};

class LevelDB {
	leveldb::DB* db;
	leveldb::Iterator* it;
	leveldb::Options options;
	leveldb::WriteOptions write_options;
	leveldb::ReadOptions read_options;
	leveldb::WriteBatch batch;
	
public:
	LevelDB() : db(NULL), it(NULL) {}
	LevelDB(const char* name,HV* hv_options=NULL) {
		db = NULL; it = NULL;
		Open(name,hv_options);
	}
	void Open(const char* name,HV* hv_options=NULL) {
		options.create_if_missing = true;
		status_assert(leveldb::DB::Open(options,name,&db));
	}
	~LevelDB() { 
		if(it) delete it;
		if(db) delete db;
	}
	SV* FETCH(SV* sv_key) {
		std::string key = SV2string(sv_key);
		std::string value;
		leveldb::Status s = db->Get(read_options,key,&value);
		if(s.IsNotFound()) return newSV(0);
		status_assert(s);
		return newSVstring(value);
	}
	void STORE(SV* sv_key,SV* sv_value) {
		std::string key = SV2string(sv_key);
		std::string value = SV2string(sv_value);
		status_assert(db->Put(write_options,key,value));
	}
	void DELETE(SV* sv_key) {
		std::string key = SV2string(sv_key);
		status_assert(db->Delete(write_options,key));
	}
	void CLEAR() {
		leveldb::WriteBatch batch;
		leveldb::Iterator* it = db->NewIterator(read_options);
		for(it->SeekToFirst();it->Valid();it->Next()) 
			batch.Delete(it->key().ToString().c_str()); // TODO: c_str()??
		delete it;
		status_assert(db->Write(write_options,&batch));
	}
	bool EXISTS(SV* sv_key) {
		std::string key = SV2string(sv_key);
		leveldb::Iterator* find = db->NewIterator(read_options);
		find->Seek(key);
		bool valid = find->Valid();
		delete(find);
		return valid;
	}
	SV* FIRSTKEY() {
		if(it) delete it;
		it = db->NewIterator(read_options);
		it->SeekToFirst();
		return it->Valid() ? newSVslice(it->key()) : newSV(0);
	}
	SV* NEXTKEY(SV* sv_lastkey) {
		if(!it) return NULL;
		it->Next();
		return it->Valid() ? newSVslice(it->key()) : newSV(0);
	}
	int SCALAR() {
		int count = 0;
		leveldb::Iterator* it = db->NewIterator(read_options);
		for(it->SeekToFirst();it->Valid();it->Next()) count++;
		delete it;
		return count;
	}
};

#line 228 "LevelDB.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 372 "LevelDB.c"

XS_EUPXS(XS_Tie__LevelDB__DB_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "CLASS, name=NULL, hv_options=Nullhv");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	DB *	RETVAL;
	char*	name;
	HV*	hv_options;

	if (items < 2)
	    name = NULL;
	else {
	    name = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    hv_options = Nullhv;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			hv_options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Tie::LevelDB::DB::new",
				    "hv_options");
		    }
	    } STMT_END
;
	}

	RETVAL = new DB(name, hv_options);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB__DB_Open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_Open)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, name, hv_options=Nullhv");
    {
	DB *	THIS;
	char*	name = (char *)SvPV_nolen(ST(1))
;
	HV*	hv_options;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DB::Open() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if (items < 3)
	    hv_options = Nullhv;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			hv_options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Tie::LevelDB::DB::Open",
				    "hv_options");
		    }
	    } STMT_END
;
	}

	THIS->Open(name, hv_options);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__DB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DB *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DB::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__DB_Put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_Put)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, key, value=NULL");
    {
	DB *	THIS;
	char*	key = (char *)SvPV_nolen(ST(1))
;
	char*	value;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DB::Put() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if (items < 3)
	    value = NULL;
	else {
	    value = (char *)SvPV_nolen(ST(2))
;
	}

	THIS->Put(key, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__DB_Get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_Get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    {
	DB *	THIS;
	SV *	RETVAL;
	const char *	key = (const char *)SvPV_nolen(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DB::Get() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->Get(key);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB__DB_Delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_Delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    {
	DB *	THIS;
	char *	key = (char *)SvPV_nolen(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DB::Delete() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->Delete(key);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__DB_NewIterator); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_NewIterator)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, hv_read_options=Nullhv");
    {
	DB *	THIS;
	Iterator *	RETVAL;
	HV*	hv_read_options;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DB::NewIterator() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if (items < 2)
	    hv_read_options = Nullhv;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(1);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			hv_read_options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Tie::LevelDB::DB::NewIterator",
				    "hv_read_options");
		    }
	    } STMT_END
;
	}
#line 241 "LevelDB.xs"
		const char* CLASS = "Tie::LevelDB::Iterator";
		RETVAL = THIS->NewIterator(hv_read_options);
#line 616 "LevelDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB__DB_Write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__DB_Write)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, batch, hv_write_options=Nullhv");
    {
	DB *	THIS;
	WriteBatch*	batch;
	HV*	hv_write_options;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DB::Write() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		batch = (WriteBatch *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Tie::LevelDB::DB::Write() -- batch is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if (items < 3)
	    hv_write_options = Nullhv;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			hv_write_options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Tie::LevelDB::DB::Write",
				    "hv_write_options");
		    }
	    } STMT_END
;
	}

	THIS->Write(batch, hv_write_options);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__WriteBatch_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__WriteBatch_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	WriteBatch *	RETVAL;

	RETVAL = new WriteBatch();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB__WriteBatch_Put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__WriteBatch_Put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, key, value");
    {
	WriteBatch *	THIS;
	const char*	key = (const char *)SvPV_nolen(ST(1))
;
	const char*	value = (const char *)SvPV_nolen(ST(2))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WriteBatch *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::WriteBatch::Put() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->Put(key, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__WriteBatch_Delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__WriteBatch_Delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    {
	WriteBatch *	THIS;
	const char*	key = (const char *)SvPV_nolen(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WriteBatch *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::WriteBatch::Delete() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->Delete(key);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__WriteBatch_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__WriteBatch_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WriteBatch *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WriteBatch *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::WriteBatch::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	Iterator *	RETVAL;

	RETVAL = new Iterator();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_Seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_Seek)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, sv_target");
    {
	Iterator *	THIS;
	SV*	sv_target = ST(1)
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::Seek() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->Seek(sv_target);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_SeekToFirst); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_SeekToFirst)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::SeekToFirst() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->SeekToFirst();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_SeekToLast); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_SeekToLast)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::SeekToLast() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->SeekToLast();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_Prev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_Prev)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::Prev() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->Prev();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_Next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_Next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::Next() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->Next();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_Valid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_Valid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::Valid() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->Valid();
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;
	SV *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::key() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->key();
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB__Iterator_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB__Iterator_value)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Iterator *	THIS;
	SV *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Iterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::Iterator::value() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->value();
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	LevelDB *	RETVAL;

	RETVAL = new LevelDB();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    {
	LevelDB *	THIS;
	SV *	RETVAL;
	SV*	key = ST(1)
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::FETCH() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->FETCH(key);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_STORE)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "THIS, sv_key, ...");
    {
	LevelDB *	THIS;
	SV*	sv_key = ST(1)
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::STORE() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 306 "LevelDB.xs"
		if(SvOK(ST(2))) THIS->STORE(sv_key,ST(2));
				   else THIS->DELETE(sv_key);
#line 1089 "LevelDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB_DELETE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_DELETE)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, sv_key");
    {
	LevelDB *	THIS;
	SV*	sv_key = ST(1)
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DELETE() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->DELETE(sv_key);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_CLEAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LevelDB *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::CLEAR() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->CLEAR();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB_EXISTS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_EXISTS)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, sv_key");
    {
	LevelDB *	THIS;
	bool	RETVAL;
	SV*	sv_key = ST(1)
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::EXISTS() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->EXISTS(sv_key);
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LevelDB *	THIS;
	SV *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::FIRSTKEY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->FIRSTKEY();
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, sv_lastkey");
    {
	LevelDB *	THIS;
	SV *	RETVAL;
	SV*	sv_lastkey = ST(1)
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::NEXTKEY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->NEXTKEY(sv_lastkey);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB_SCALAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_SCALAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LevelDB *	THIS;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::SCALAR() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->SCALAR();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__LevelDB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LevelDB *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LevelDB *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Tie::LevelDB::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__LevelDB_TIEHASH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__LevelDB_TIEHASH)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "CLASS, name, hv_options=Nullhv");
    {
	LevelDB *	RETVAL;
	const char*	CLASS = (const char *)SvPV_nolen(ST(0))
;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;
	HV*	hv_options;

	if (items < 3)
	    hv_options = Nullhv;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			hv_options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Tie::LevelDB::TIEHASH",
				    "hv_options");
		    }
	    } STMT_END
;
	}
#line 333 "LevelDB.xs"
    RETVAL = new LevelDB(name,hv_options);
#line 1307 "LevelDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Tie__LevelDB); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Tie__LevelDB)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Tie::LevelDB::DB::new", XS_Tie__LevelDB__DB_new);
        newXS_deffile("Tie::LevelDB::DB::Open", XS_Tie__LevelDB__DB_Open);
        newXS_deffile("Tie::LevelDB::DB::DESTROY", XS_Tie__LevelDB__DB_DESTROY);
        newXS_deffile("Tie::LevelDB::DB::Put", XS_Tie__LevelDB__DB_Put);
        newXS_deffile("Tie::LevelDB::DB::Get", XS_Tie__LevelDB__DB_Get);
        newXS_deffile("Tie::LevelDB::DB::Delete", XS_Tie__LevelDB__DB_Delete);
        newXS_deffile("Tie::LevelDB::DB::NewIterator", XS_Tie__LevelDB__DB_NewIterator);
        newXS_deffile("Tie::LevelDB::DB::Write", XS_Tie__LevelDB__DB_Write);
        newXS_deffile("Tie::LevelDB::WriteBatch::new", XS_Tie__LevelDB__WriteBatch_new);
        newXS_deffile("Tie::LevelDB::WriteBatch::Put", XS_Tie__LevelDB__WriteBatch_Put);
        newXS_deffile("Tie::LevelDB::WriteBatch::Delete", XS_Tie__LevelDB__WriteBatch_Delete);
        newXS_deffile("Tie::LevelDB::WriteBatch::DESTROY", XS_Tie__LevelDB__WriteBatch_DESTROY);
        newXS_deffile("Tie::LevelDB::Iterator::new", XS_Tie__LevelDB__Iterator_new);
        newXS_deffile("Tie::LevelDB::Iterator::DESTROY", XS_Tie__LevelDB__Iterator_DESTROY);
        newXS_deffile("Tie::LevelDB::Iterator::Seek", XS_Tie__LevelDB__Iterator_Seek);
        newXS_deffile("Tie::LevelDB::Iterator::SeekToFirst", XS_Tie__LevelDB__Iterator_SeekToFirst);
        newXS_deffile("Tie::LevelDB::Iterator::SeekToLast", XS_Tie__LevelDB__Iterator_SeekToLast);
        newXS_deffile("Tie::LevelDB::Iterator::Prev", XS_Tie__LevelDB__Iterator_Prev);
        newXS_deffile("Tie::LevelDB::Iterator::Next", XS_Tie__LevelDB__Iterator_Next);
        newXS_deffile("Tie::LevelDB::Iterator::Valid", XS_Tie__LevelDB__Iterator_Valid);
        newXS_deffile("Tie::LevelDB::Iterator::key", XS_Tie__LevelDB__Iterator_key);
        newXS_deffile("Tie::LevelDB::Iterator::value", XS_Tie__LevelDB__Iterator_value);
        newXS_deffile("Tie::LevelDB::new", XS_Tie__LevelDB_new);
        newXS_deffile("Tie::LevelDB::FETCH", XS_Tie__LevelDB_FETCH);
        newXS_deffile("Tie::LevelDB::STORE", XS_Tie__LevelDB_STORE);
        newXS_deffile("Tie::LevelDB::DELETE", XS_Tie__LevelDB_DELETE);
        newXS_deffile("Tie::LevelDB::CLEAR", XS_Tie__LevelDB_CLEAR);
        newXS_deffile("Tie::LevelDB::EXISTS", XS_Tie__LevelDB_EXISTS);
        newXS_deffile("Tie::LevelDB::FIRSTKEY", XS_Tie__LevelDB_FIRSTKEY);
        newXS_deffile("Tie::LevelDB::NEXTKEY", XS_Tie__LevelDB_NEXTKEY);
        newXS_deffile("Tie::LevelDB::SCALAR", XS_Tie__LevelDB_SCALAR);
        newXS_deffile("Tie::LevelDB::DESTROY", XS_Tie__LevelDB_DESTROY);
        newXS_deffile("Tie::LevelDB::TIEHASH", XS_Tie__LevelDB_TIEHASH);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
